unit Data;

interface

uses
  SysUtils, Classes,
  QForms, DB, DBXpress, SqlExpr,
  mtrClient, mtrServer, mtrCustomServers;

type
  TdmMain = class(TDataModule)
    mtrClient: TmtrClient;
    mtrServer: TmtrDBXServer;
    SQLCon: TSQLConnection;
    procedure mtrClientPrintBand(const AMax, ACurrent: Integer;
      var AFinish: Boolean);
    procedure mtrClientAfterExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Connect(const ADataBase, ALoginName, APassword: string);
    procedure Disconnect;
    procedure ShowAbout;
  end;

var
  dmMain: TdmMain;

implementation

uses About, Progress;

{$R *.xfm}

{ TdmMain }

procedure TdmMain.Connect(const ADataBase, ALoginName, APassword: string);
begin
{$IFDEF LINUX}
  SQLCon.ConnectionName := 'IBLocal';
  SQLCon.DriverName := 'INTERBASE';
  SQLCon.GetDriverFunc := 'getSQLDriverINTERBASE';
  SQLCon.LibraryName := 'libsqlib.so.1';
  SQLCon.VendorLib := 'libgds.so';
{$ENDIF}
{$IFDEF MSWINDOWS}
  SQLCon.ConnectionName := 'IBLocal';
  SQLCon.DriverName := 'Interbase';
  SQLCon.GetDriverFunc := 'getSQLDriverINTERBASE';
  SQLCon.LibraryName := 'dbexpint.dll';
  SQLCon.VendorLib := 'GDS32.DLL';
{$ENDIF}
  SQLCon.Params.Values['Database'] := ADataBase;
  SQLCon.Params.Values['User_Name'] := ALoginName;
  SQLCon.Params.Values['Password'] := APassword;
  SQLCon.Open;
end;

procedure TdmMain.Disconnect;
begin
  SQLCon.Close;
end;

procedure TdmMain.ShowAbout;
begin
  fmAbout.ShowModal;
end;

procedure TdmMain.mtrClientPrintBand(const AMax, ACurrent: Integer;
  var AFinish: Boolean);
begin
  with fmProgress do begin
    ProgressBar.Max := AMax;
    ProgressBar.Position := ACurrent;
    if not Visible then begin
      Show;
      SetFocus;
    end;
    Application.ProcessMessages;
    AFinish := Cancel;
    Cancel := false;
  end;
end;

procedure TdmMain.mtrClientAfterExecute(Sender: TObject);
begin
  if fmProgress.Visible then fmProgress.Close;
end;

end.
