unit Global;

interface

uses Classes, Variants;

function MemoryStream2OleVariant(AStream: TMemoryStream): OleVariant;
procedure OleVariant2MemoryStream(AValue: OleVariant; AStream: TMemoryStream);

implementation

function MemoryStream2OleVariant(AStream: TMemoryStream): OleVariant;
var
  p: pointer;
begin
  result := VarArrayCreate([0, AStream.Size-1],varByte);
  p := VarArrayLock(result);
  try
    move(AStream.Memory^, p^, AStream.Size);
  finally
    VarArrayUnLock(result);
  end;
end;

procedure OleVariant2MemoryStream(AValue: OleVariant; AStream: TMemoryStream);
var
  size: integer;
  p: pointer;
begin
  { for variant array of byte only}
  if TVarData(AValue).VType and varArray = 0 then Exit;
  size := VarArrayHighBound(AValue, 1) + 1;
  p := VarArrayLock(AValue);
  try
    AStream.SetSize(size);
    move(p^, AStream.Memory^, size);
  finally
    VarArrayUnLock(AValue);
  end;
end;

end.
